
Global $i, $inputfile, $inputfileopen, $inputfileread, $j, $k, $linefirstsplit, $linesecondsplit, $linethirdsplit, $outputfile, $outputfileopen, $seglines, $segments, $segnumber, $sourceline, $sourcemarkedline, $sourcemergedline, $sourcemergedline, $sourceterm, $targetline, $targetmarkedline, $targetmergedline, $targetterm, $targetterm, $goodmessage, $failmessage, $notermfound, $rawsegnumber, $rawsegnumsplit


#cs

WFC Glossary Rechecker v2
by Samuel Murray

FIXED some bugs

This script reads a WFC QC report and spits out a character-based report.

#ce

MsgBox (0, "WFC Glossary Rechecker, v2", "How to use:" & @CRLF & @CRLF & "1. Do a QC in WFC" & @CRLF & "2. Select, copy and paste all text to a plain text file, and save as UTF8" & @CRLF & "3. Run the WFC Glossary Rechecker on the file" & @CRLF & "4. Open the output file in MS Word" & @CRLF & "5. Convert to table (4 columns)" & @CRLF & "6. Highlight the stuff between [[ and ]]" & @CRLF & @CRLF & "* 'FAIL' means the target term was not found in the target line" & @CRLF & "* 'NO TERM FOUND' means could not figure what the terms are" & @CRLF & "* 'unknown' means the same as 'NO TERM FOUND'" & @CRLF & @CRLF & "You must select/copy/paste into a Unicode text editor. If you simply use 'Save As' in MS Word, it won't save all the hidden text, not even if you used Ctrl+Shift+Z. Non-glossary QC items are ignored.", 0)

$j = 0 ; for counting
$k = 0 ; for counting
$notermfound = 0

$inputfile = FileOpenDialog ("Select WFC QC Report in TXT format", @ScriptDir, "Text files (*.txt)|All (*.*)")

$inputfileopen = FileOpen ($inputfile, 128)
$inputfileread2 = FileRead ($inputfileopen)

$inputfileread = StringReplace ($inputfileread2, "], [", ", ") ; to fix a bug

$outputfile = FileSaveDialog ("Set a name for the output file", @ScriptDir, "Text files (*.txt)|All (*.*)", 18, "outputfile.txt")

$outputfileopen = FileOpen ($outputfile, 129)

$segments = StringSplit ($inputfileread, "{id=", 1)

For $i = 1 to $segments[0]

If StringInStr ($segments[$i], "} GLOSSARY") Then

$seglines = StringSplit ($segments[$i], @CRLF, 1)

; First, get the various terms and lines

$seglines[1] = StringReplace($seglines[1], "[", "[")

If @Extended = 2 Then

$linefirstsplit = StringSplit ($seglines[1], "[", 1)

$linesecondsplit = StringSplit ($linefirstsplit[2], "]", 1)
$sourceterm = $linesecondsplit[1]
$linethirdsplit = StringSplit ($linefirstsplit[3], "]", 1)
$targetterm = $linethirdsplit[1]

Else

$notermfound = 1
$sourceterm = "NO TERM FOUND"
$targetterm = "NO TERM FOUND"

EndIf

$rawsegnumber = $linefirstsplit[1]
$rawsegnumsplit = StringSplit ($rawsegnumber, "}", 1)
If $rawsegnumsplit[0] = 2 Then
$segnumber = $rawsegnumsplit[1]
Else
$segnumber = $linefirstsplit[1]
EndIf

$sourceline = $seglines[2]
$targetline = $seglines[3]

; Then, do a comparison

$goodmessage = "..."
$failmessage = "FAIL!!!"

If $notermfound = 1 Then
$failmessage = "unknown"
If StringInStr ($sourceline, "(...)") Then
$failmessage = "truncated?"
ElseIf StringInStr ($targetline, "(...)") Then
$failmessage = "truncated?"
EndIf
$notermfound = 0
EndIf

If StringInStr ($sourceline, $sourceterm) Then
$sourcemarkedline = StringReplace ($sourceline, $sourceterm, "[[" & $sourceterm & "]]")
$sourcemergedline = $sourceterm & @TAB & $sourcemarkedline & @TAB & $goodmessage
Else
$sourcemergedline = $sourceterm & @TAB & $sourceline & @TAB & $failmessage
EndIf

If StringInStr ($targetline, $targetterm) Then
$targetmarkedline = StringReplace ($targetline, $targetterm, "[[" & $targetterm & "]]")
$targetmergedline = $targetterm & @TAB & $targetmarkedline & @TAB & $goodmessage
Else
$targetmergedline = $targetterm & @TAB & $targetline & @TAB & $failmessage
EndIf

; Then write to a file

FileWrite ($outputfileopen, $segnumber & @TAB & $sourcemergedline & @CRLF & $segnumber & @TAB & $targetmergedline & @CRLF)

$j = $j + 1

EndIf

$k = $k + 1

Next

MsgBox (0, "Done!", "Read " & $k & " segments and evaluated " & $j & " mismatches.", 0)


